package array_list

import (
	"encoding/json"
)

func (a *ArrayList[T]) MarshalXML() ([]byte, error) {
	return json.Marshal(a.content[:a.size])
}

func (a *ArrayList[T]) UnmarshalXML(data []byte) error {
	var content []T
	if err := json.Unmarshal(data, &content); err != nil {
		return err
	}

	a.content = content
	a.size = len(content)
	return nil
}
